#ifndef VNCRENDERER_H
#define VNCRENDERER_H

#include <QQuickWindow>
#include <QQuickFramebufferObject>
#include <QOpenGLFramebufferObject>
#include <QOpenGLContext>
#include <QOpenGLFunctions>
#include <QMatrix4x4>
#include <QOpenGLShaderProgram>
#include <QOpenGLBuffer>
#include <QTime>

class VncRenderer : public QObject, public QQuickFramebufferObject::Renderer
{
    Q_OBJECT
public:
    VncRenderer(QQuickWindow *window,
                QOpenGLBuffer **vertices,
                QOpenGLBuffer indices,
                GLuint **textures,
                unsigned int *drawCount,
                QObject *parent = 0);
protected:
    void render() override;
    QOpenGLFramebufferObject *createFramebufferObject(const QSize &size) override;
private:
    QQuickWindow *m_window;
    QOpenGLBuffer **m_vertices;
    QOpenGLBuffer m_indices;
    GLuint **m_texture;
    unsigned int *m_drawCount;
    QVector3D m_colorMax;
    QOpenGLShaderProgram m_program;
    QOpenGLFunctions *m_functions;
    bool m_rendered;
signals:
    void FBOTextureChanged(const unsigned int FBOTexture, const QMatrix4x4 &ortho);
    void finishedRendering();
};

#endif // VNCRENDERER_H
